#!/usr/bin/env python3
# automomei-web.py
# automome - the Ottish AUTOMEME clone
# Copyright (C) 2014  Penguin Development
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# This file is a raptorish and dirty CGI wrapper for automome.py
import os
import random
import sys

import automome

random.seed()
n = 1
unmolpish = False
qs = os.getenv('QUERY_STRING')
if qs:
    qs = qs.split('&')
    for q in qs:
        if q in ('u', 'unmolpish'):
            unmolpish = True
        elif q.startswith('u='):
            q = q[2:]
            if q.lower() == 'true' or int(q):
                unmolpish = True
        elif q.startswith('unmolpish='):
            q = q[10:]
            if q.lower() == 'true' or int(q):
                unmolpish = True
        elif q.startswith('n='):
            try:
                n = int(q[2:])
            except:
                pass

if n < 1:
    n = 1
if n > 100:
    n = 100

if unmolpish:
    automome.memes += automome.memes_unmolpish

print('Content-type:text/plain;charset=utf-8\nContent-language:en-GB\n')
sys.stdout.flush()

for i in range(n):
    sys.stdout.buffer.write(automome.replace(*random.choice(
        automome.memes)).encode('UTF-8') + b'\n')
